diff --git a/src/util-mpm-wumanber.h b/src/util-mpm-wumanber.h
index edbd66a..660058f 100644
--- a/src/util-mpm-wumanber.h
+++ b/src/util-mpm-wumanber.h
@@ -11,6 +11,9 @@
 
 //#define WUMANBER_COUNTERS
 
+#define WM_INIT_HASH_SIZE 65535
+
+
 typedef struct WmPattern_ {
     uint8_t *cs; /* case sensitive */
     uint8_t *ci; /* case INsensitive */
@@ -84,6 +87,263 @@ typedef struct WmThreadCtx_ {
 } WmThreadCtx;
 
 void MpmWuManberRegister(void);
+void WmFreePattern(MpmCtx *, WmPattern *);
+
+/** ---- Inline functions ---- */
+
+static inline uint32_t WmScan(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
+static inline uint32_t WmSearch(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
+
+/* append an endmatch to a pattern
+ *
+ * Only used in the initialization phase */
+static inline void WmEndMatchAppend(MpmCtx *mpm_ctx, WmPattern *p,
+    uint16_t offset, uint16_t depth, uint32_t pid, uint32_t sid,
+    uint8_t nosearch)
+{
+    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
+    if (em == NULL) {
+        printf("ERROR: WmAllocEndMatch failed\n");
+        return;
+    }
+
+    em->id = pid;
+    em->sig_id = sid;
+    em->depth = depth;
+    em->offset = offset;
+
+    if (nosearch)
+        em->flags |= MPM_ENDMATCH_NOSEARCH;
+
+    if (p->em == NULL) {
+        p->em = em;
+        return;
+    }
+
+    MpmEndMatch *m = p->em;
+    while (m->next) {
+        m = m->next;
+    }
+    m->next = em;
+}
+
+static inline WmPattern *WmAllocPattern(MpmCtx *mpm_ctx) {
+    WmPattern *p = SCMalloc(sizeof(WmPattern));
+    if (p == NULL) {
+        printf("ERROR: WmAllocPattern: SCMalloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(p,0,sizeof(WmPattern));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(WmPattern);
+    return p;
+}
+
+
+static inline WmHashItem *
+WmAllocHashItem(MpmCtx *mpm_ctx) {
+    WmHashItem *hi = SCMalloc(sizeof(WmHashItem));
+    if (hi == NULL) {
+        printf("ERROR: WmAllocHashItem: SCMalloc failed\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(hi,0,sizeof(WmHashItem));
+
+    mpm_ctx->memory_cnt++;
+    mpm_ctx->memory_size += sizeof(WmHashItem);
+    return hi;
+}
+
+static inline uint32_t WmInitHash(WmPattern *p) {
+    uint32_t hash = p->len * p->cs[0];
+    if (p->len > 1)
+        hash += p->cs[1];
+
+    return (hash % WM_INIT_HASH_SIZE);
+}
+
+static inline uint32_t WmInitHashRaw(uint8_t *pat, uint16_t patlen) {
+    uint32_t hash = patlen * pat[0];
+    if (patlen > 1)
+        hash += pat[1];
+
+    return (hash % WM_INIT_HASH_SIZE);
+}
+
+static inline int WmInitHashAdd(WmCtx *ctx, WmPattern *p) {
+    uint32_t hash = WmInitHash(p);
+
+    //printf("WmInitHashAdd: %" PRIu32 "\n", hash);
+
+    if (ctx->init_hash[hash] == NULL) {
+        ctx->init_hash[hash] = p;
+        //printf("WmInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+        return 0;
+    }
+
+    WmPattern *tt = NULL;
+    WmPattern *t = ctx->init_hash[hash];
+
+    /* get the list tail */
+    do {
+        tt = t;
+        t = t->next;
+    } while (t != NULL);
+
+    tt->next = p;
+    //printf("WmInitHashAdd: hash %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+
+    return 0;
+}
+
+static inline int WmCmpPattern(WmPattern *p, uint8_t *pat, uint16_t patlen, char nocase);
+
+static inline WmPattern *WmInitHashLookup(WmCtx *ctx, uint8_t *pat, uint16_t patlen, char nocase) {
+    uint32_t hash = WmInitHashRaw(pat,patlen);
+
+    //printf("WmInitHashLookup: %" PRIu32 ", head %p\n", hash, ctx->init_hash[hash]);
+
+    if (ctx->init_hash[hash] == NULL) {
+        return NULL;
+    }
+
+    WmPattern *t = ctx->init_hash[hash];
+    for ( ; t != NULL; t = t->next) {
+        if (WmCmpPattern(t,pat,patlen,nocase) == 1)
+            return t;
+    }
+
+    return NULL;
+}
+
+static inline int WmCmpPattern(WmPattern *p, uint8_t *pat, uint16_t patlen, char nocase) {
+    if (p->len != patlen)
+        return 0;
+
+    if (!((nocase && p->flags & WUMANBER_NOCASE) || (!nocase && !(p->flags & WUMANBER_NOCASE))))
+        return 0;
+
+    if (memcmp(p->cs, pat, patlen) != 0)
+        return 0;
+
+    return 1;
+}
+
+/* WmAddPattern
+ *
+ * pat: ptr to the pattern
+ * patlen: length of the pattern
+ * nocase: nocase flag: 1 enabled, 0 disable
+ * pid: pattern id
+ * sid: signature id (internal id)
+ */
+static inline int WmAddPattern(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen, uint16_t offset, uint16_t depth, char nocase, char scan, uint32_t pid, uint32_t sid, uint8_t nosearch) {
+    WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
+
+//    printf("WmAddPattern: ctx %p \"", mpm_ctx); prt(pat, patlen);
+//    printf("\" id %" PRIu32 ", nocase %s\n", id, nocase ? "true" : "false");
+
+    if (patlen == 0)
+        return 0;
+
+    /* get a memory piece */
+    WmPattern *p = WmInitHashLookup(ctx, pat, patlen, nocase);
+    if (p == NULL) {
+//        printf("WmAddPattern: allocing new pattern\n");
+        p = WmAllocPattern(mpm_ctx);
+        if (p == NULL)
+            goto error;
+
+        p->len = patlen;
+
+        if (nocase) p->flags |= WUMANBER_NOCASE;
+
+        /* setup the case insensitive part of the pattern */
+        p->ci = SCMalloc(patlen);
+        if (p->ci == NULL) goto error;
+        mpm_ctx->memory_cnt++;
+        mpm_ctx->memory_size += patlen;
+        memcpy_tolower(p->ci, pat, patlen);
+
+        /* setup the case sensitive part of the pattern */
+        if (p->flags & WUMANBER_NOCASE) {
+            /* nocase means no difference between cs and ci */
+            p->cs = p->ci;
+        } else {
+            if (memcmp(p->ci,pat,p->len) == 0) {
+                /* no diff between cs and ci: pat is lowercase */
+                p->cs = p->ci;
+            } else {
+                p->cs = SCMalloc(patlen);
+                if (p->cs == NULL) goto error;
+                mpm_ctx->memory_cnt++;
+                mpm_ctx->memory_size += patlen;
+                memcpy(p->cs, pat, patlen);
+            }
+        }
+
+        if (p->len > 1) {
+            p->prefix_cs = (uint16_t)(*(p->cs)+*(p->cs+1));
+            p->prefix_ci = (uint16_t)(*(p->ci)+*(p->ci+1));
+        }
+
+        //printf("WmAddPattern: ci \""); prt(p->ci,p->len);
+        //printf("\" cs \""); prt(p->cs,p->len);
+        //printf("\" prefix_ci %" PRIu32 ", prefix_cs %" PRIu32 "\n", p->prefix_ci, p->prefix_cs);
+
+        /* put in the pattern hash */
+        WmInitHashAdd(ctx, p);
+
+        if (mpm_ctx->pattern_cnt == 65535) {
+            printf("Max search words reached\n");
+            exit(1);
+        }
+        mpm_ctx->pattern_cnt++;
+
+        if (scan) { /* SCAN */
+            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
+            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
+            p->flags |= WUMANBER_SCAN;
+        } else { /* SEARCH */
+            if (mpm_ctx->search_maxlen < patlen) mpm_ctx->search_maxlen = patlen;
+            if (mpm_ctx->search_minlen == 0) mpm_ctx->search_minlen = patlen;
+            else if (mpm_ctx->search_minlen > patlen) mpm_ctx->search_minlen = patlen;
+        }
+    } else {
+        /* if we're reusing a pattern, check we need to check that it is a
+         * scan pattern if that is what we're adding. If so we set the pattern
+         * to be a scan pattern. */
+        if (scan) {
+            p->flags = WUMANBER_SCAN;
+            if (mpm_ctx->scan_maxlen < patlen) mpm_ctx->scan_maxlen = patlen;
+            if (mpm_ctx->scan_minlen == 0) mpm_ctx->scan_minlen = patlen;
+            else if (mpm_ctx->scan_minlen > patlen) mpm_ctx->scan_minlen = patlen;
+        }
+    }
+
+    /* we need a match */
+    WmEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
+
+    mpm_ctx->total_pattern_cnt++;
+    return 0;
+
+error:
+    WmFreePattern(mpm_ctx, p);
+    return -1;
+}
+
+static inline uint32_t WmScan(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
+    WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
+    return ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
+}
+
+static inline uint32_t WmSearch(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx, PatternMatcherQueue *pmq, uint8_t *buf, uint16_t buflen) {
+    WmCtx *ctx = (WmCtx *)mpm_ctx->ctx;
+    return ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen);
+}
+
 
 #endif /* __UTIL_MPM_WUMANBER_H__ */
 
diff --git a/src/util-mpm.c b/src/util-mpm.c
index 2252945..1c82e8b 100644
--- a/src/util-mpm.c
+++ b/src/util-mpm.c
@@ -123,111 +123,6 @@ MpmMatchCleanup(MpmThreadCtx *thread_ctx) {
     }
 }
 
-/** \brief allocate a match
- *
- * used at search runtime */
-inline MpmMatch *
-MpmMatchAlloc(MpmThreadCtx *thread_ctx) {
-    MpmMatch *m = SCMalloc(sizeof(MpmMatch));
-    if (m == NULL)
-        return NULL;
-
-    thread_ctx->memory_cnt++;
-    thread_ctx->memory_size += sizeof(MpmMatch);
-
-    m->offset = 0;
-    m->next = NULL;
-    m->qnext = NULL;
-    m->mb = NULL;
-    return m;
-}
-
-/** \brief append a match to a bucket
- *
- * used at search runtime */
-inline int
-MpmMatchAppend(MpmThreadCtx *thread_ctx, PatternMatcherQueue *pmq, MpmEndMatch *em, MpmMatchBucket *mb, uint16_t offset, uint16_t patlen)
-{
-    /* don't bother looking at sigs that didn't match
-     * when we scanned. There's no matching anyway. */
-    if (pmq != NULL && pmq->mode == PMQ_MODE_SEARCH) {
-        if (!(pmq->sig_bitarray[(em->sig_id / 8)] & (1<<(em->sig_id % 8))))
-            return 0;
-    }
-
-    /* if our endmatch is set to a single match being enough,
-       we're not going to add more if we already have one */
-    if (em->flags & MPM_ENDMATCH_SINGLE && mb->len)
-        return 0;
-
-    /* check offset */
-    if (offset < em->offset)
-        return 0;
-
-    /* check depth */
-    if (em->depth && (offset+patlen) > em->depth)
-        return 0;
-
-    /* ok all checks passed, now append the match */
-    MpmMatch *m;
-    /* pull a match from the spare list */
-    if (thread_ctx->sparelist != NULL) {
-        m = thread_ctx->sparelist;
-        thread_ctx->sparelist = m->qnext;
-    } else {
-        m = MpmMatchAlloc(thread_ctx);
-        if (m == NULL)
-            return 0;
-    }
-
-    m->offset = offset;
-    m->mb = mb;
-    m->next = NULL;
-    m->qnext = NULL;
-
-    /* append to the mb list */
-    if (mb->bot == NULL) { /* empty list */
-        mb->top = m;
-        mb->bot = m;
-    } else { /* more items in list */
-        mb->bot->next = m;
-        mb->bot = m;
-    }
-
-    mb->len++;
-
-    /* put in the queue list */
-    if (thread_ctx->qlist == NULL) { /* empty list */
-        thread_ctx->qlist = m;
-    } else { /* more items in list */
-        m->qnext = thread_ctx->qlist;
-        thread_ctx->qlist = m;
-    }
-
-    BUG_ON(m == m->qnext);
-
-    if (pmq != NULL) {
-        /* make sure we only append a sig with a matching pattern once,
-         * so we won't inspect it more than once. For this we keep a
-         * bitarray of sig internal id's and flag each sig that matched */
-        if (!(pmq->sig_bitarray[(em->sig_id / 8)] & (1<<(em->sig_id % 8)))) {
-            /* flag this sig_id as being added now */
-            pmq->sig_bitarray[(em->sig_id / 8)] |= (1<<(em->sig_id % 8));
-            /* append the sig_id to the array with matches */
-            pmq->sig_id_array[pmq->sig_id_array_cnt] = em->sig_id;
-            pmq->sig_id_array_cnt++;
-        }
-
-        /* nosearch flag */
-        if (pmq->mode == PMQ_MODE_SCAN && !(em->flags & MPM_ENDMATCH_NOSEARCH)) {
-            pmq->searchable++;
-        }
-    }
-
-    SCLogDebug("len %" PRIu32 " (offset %" PRIu32 ")", mb->len, m->offset);
-    return 1;
-}
-
 void MpmMatchFree(MpmThreadCtx *ctx, MpmMatch *m) {
     ctx->memory_cnt--;
     ctx->memory_size -= sizeof(MpmMatch);
diff --git a/src/util-mpm.h b/src/util-mpm.h
index 92d23f0..952ee66 100644
--- a/src/util-mpm.h
+++ b/src/util-mpm.h
@@ -147,8 +147,6 @@ void PmqCleanup(PatternMatcherQueue *);
 void PmqFree(PatternMatcherQueue *);
 
 void MpmMatchCleanup(MpmThreadCtx *);
-MpmMatch *MpmMatchAlloc(MpmThreadCtx *);
-int MpmMatchAppend(MpmThreadCtx *, PatternMatcherQueue *, MpmEndMatch *, MpmMatchBucket *, uint16_t, uint16_t);
 MpmEndMatch *MpmAllocEndMatch (MpmCtx *);
 void MpmEndMatchFreeAll(MpmCtx *mpm_ctx, MpmEndMatch *em);
 void MpmMatchFreeSpares(MpmThreadCtx *mpm_ctx, MpmMatch *m);
@@ -164,5 +162,114 @@ void MpmInitThreadCtx(MpmThreadCtx *mpm_thread_ctx, uint16_t, uint32_t);
 uint32_t MpmGetHashSize(const char *);
 uint32_t MpmGetBloomSize(const char *);
 
+/** ------ Inline functions ------- */
+
+static inline MpmMatch *MpmMatchAlloc(MpmThreadCtx *);
+static inline int MpmMatchAppend(MpmThreadCtx *, PatternMatcherQueue *, MpmEndMatch *, MpmMatchBucket *, uint16_t, uint16_t);
+
+/** \brief allocate a match
+ *
+ * used at search runtime */
+static inline MpmMatch *
+MpmMatchAlloc(MpmThreadCtx *thread_ctx) {
+    MpmMatch *m = SCMalloc(sizeof(MpmMatch));
+    if (m == NULL)
+        return NULL;
+
+    thread_ctx->memory_cnt++;
+    thread_ctx->memory_size += sizeof(MpmMatch);
+
+    m->offset = 0;
+    m->next = NULL;
+    m->qnext = NULL;
+    m->mb = NULL;
+    return m;
+}
+
+/** \brief append a match to a bucket
+ *
+ * used at search runtime */
+static inline int
+MpmMatchAppend(MpmThreadCtx *thread_ctx, PatternMatcherQueue *pmq, MpmEndMatch *em, MpmMatchBucket *mb, uint16_t offset, uint16_t patlen)
+{
+    /* don't bother looking at sigs that didn't match
+     * when we scanned. There's no matching anyway. */
+    if (pmq != NULL && pmq->mode == PMQ_MODE_SEARCH) {
+        if (!(pmq->sig_bitarray[(em->sig_id / 8)] & (1<<(em->sig_id % 8))))
+            return 0;
+    }
+
+    /* if our endmatch is set to a single match being enough,
+       we're not going to add more if we already have one */
+    if (em->flags & MPM_ENDMATCH_SINGLE && mb->len)
+        return 0;
+
+    /* check offset */
+    if (offset < em->offset)
+        return 0;
+
+    /* check depth */
+    if (em->depth && (offset+patlen) > em->depth)
+        return 0;
+
+    /* ok all checks passed, now append the match */
+    MpmMatch *m;
+    /* pull a match from the spare list */
+    if (thread_ctx->sparelist != NULL) {
+        m = thread_ctx->sparelist;
+        thread_ctx->sparelist = m->qnext;
+    } else {
+        m = MpmMatchAlloc(thread_ctx);
+        if (m == NULL)
+            return 0;
+    }
+
+    m->offset = offset;
+    m->mb = mb;
+    m->next = NULL;
+    m->qnext = NULL;
+
+    /* append to the mb list */
+    if (mb->bot == NULL) { /* empty list */
+        mb->top = m;
+        mb->bot = m;
+    } else { /* more items in list */
+        mb->bot->next = m;
+        mb->bot = m;
+    }
+
+    mb->len++;
+
+    /* put in the queue list */
+    if (thread_ctx->qlist == NULL) { /* empty list */
+        thread_ctx->qlist = m;
+    } else { /* more items in list */
+        m->qnext = thread_ctx->qlist;
+        thread_ctx->qlist = m;
+    }
+
+    BUG_ON(m == m->qnext);
+
+    if (pmq != NULL) {
+        /* make sure we only append a sig with a matching pattern once,
+         * so we won't inspect it more than once. For this we keep a
+         * bitarray of sig internal id's and flag each sig that matched */
+        if (!(pmq->sig_bitarray[(em->sig_id / 8)] & (1<<(em->sig_id % 8)))) {
+            /* flag this sig_id as being added now */
+            pmq->sig_bitarray[(em->sig_id / 8)] |= (1<<(em->sig_id % 8));
+            /* append the sig_id to the array with matches */
+            pmq->sig_id_array[pmq->sig_id_array_cnt] = em->sig_id;
+            pmq->sig_id_array_cnt++;
+        }
+
+        /* nosearch flag */
+        if (pmq->mode == PMQ_MODE_SCAN && !(em->flags & MPM_ENDMATCH_NOSEARCH)) {
+            pmq->searchable++;
+        }
+    }
+
+    SCLogDebug("len %" PRIu32 " (offset %" PRIu32 ")", mb->len, m->offset);
+    return 1;
+}
 #endif /* __UTIL_MPM_H__ */
 
diff --git a/src/util-radix-tree.c b/src/util-radix-tree.c
index 61849b3..53313b0 100644
--- a/src/util-radix-tree.c
+++ b/src/util-radix-tree.c
@@ -366,7 +366,7 @@ static int SCRadixPrefixNetmaskCount(SCRadixPrefix *prefix)
  * \retval 1 On match.
  * \retval 0 On no match.
  */
-static int SCRadixPrefixContainNetmaskAndSetUserData(SCRadixPrefix *prefix,
+int SCRadixPrefixContainNetmaskAndSetUserData(SCRadixPrefix *prefix,
                                                      uint16_t bitlen,
                                                      int exact_match)
 {
@@ -418,7 +418,7 @@ static int SCRadixPrefixContainNetmaskAndSetUserData(SCRadixPrefix *prefix,
  * \param prefix Pointer to a prefix instance
  * \param tree   Pointer to the Radix tree to which this prefix belongs
  */
-static void SCRadixReleasePrefix(SCRadixPrefix *prefix, SCRadixTree *tree)
+void SCRadixReleasePrefix(SCRadixPrefix *prefix, SCRadixTree *tree)
 {
     SCRadixUserData *user_data_temp1 = NULL;
     SCRadixUserData *user_data_temp2 = NULL;
@@ -445,40 +445,6 @@ static void SCRadixReleasePrefix(SCRadixPrefix *prefix, SCRadixTree *tree)
 }
 
 /**
- * \brief Creates a new node for the Radix tree
- *
- * \retval node The newly created node for the radix tree
- */
-static inline SCRadixNode *SCRadixCreateNode()
-{
-    SCRadixNode *node = NULL;
-
-    if ( (node = SCMalloc(sizeof(SCRadixNode))) == NULL) {
-        SCLogError(SC_ERR_MEM_ALLOC, "Error allocating memory");
-        exit(EXIT_FAILURE);
-    }
-    memset(node, 0, sizeof(SCRadixNode));
-
-    return node;
-}
-
-/**
- * \brief Frees a Radix tree node
- *
- * \param node Pointer to a Radix tree node
- * \param tree Pointer to the Radix tree to which this node belongs
- */
-static inline void SCRadixReleaseNode(SCRadixNode *node, SCRadixTree *tree)
-{
-    if (node != NULL) {
-        SCRadixReleasePrefix(node->prefix, tree);
-        SCFree(node);
-    }
-
-    return;
-}
-
-/**
  * \brief Creates a new Radix tree
  *
  * \param Free Function pointer supplied by the user to be used by the Radix
@@ -1251,74 +1217,6 @@ void SCRadixRemoveKeyIPV6(uint8_t *key_stream, SCRadixTree *tree)
 }
 
 /**
- * \brief Checks if an IP prefix falls under a netblock, in the path to the root
- *        of the tree, from the node.  Used internally by SCRadixFindKey()
- *
- * \param prefix Pointer to the prefix that contains the ip address
- * \param node   Pointer to the node from where we have to climb the tree
- */
-static inline SCRadixNode *SCRadixFindKeyIPNetblock(SCRadixPrefix *prefix,
-                                                    SCRadixNode *node)
-{
-    SCRadixNode *netmask_node = NULL;
-    int mask = 0;
-    int bytes = 0;
-    int i = 0;
-    int j = 0;
-
-    while (node != NULL && node->netmasks == NULL)
-        node = node->parent;
-
-    if (node == NULL)
-        return NULL;
-
-    /* hold the node found containing a netmask.  We will need it when we call
-     * this function recursively */
-    netmask_node = node;
-
-    for (j = 0; j < netmask_node->netmask_cnt; j++) {
-        bytes = prefix->bitlen / 8;
-        for (i = 0; i < bytes; i++) {
-            mask = -1;
-            if ( ((i + 1) * 8) > netmask_node->netmasks[j]) {
-                if ( ((i + 1) * 8 - netmask_node->netmasks[j]) < 8)
-                    mask = -1 << ((i + 1) * 8 - netmask_node->netmasks[j]);
-                else
-                    mask = 0;
-            }
-            prefix->stream[i] &= mask;
-        }
-
-        while (node->bit < prefix->bitlen) {
-            if (SC_RADIX_BITTEST(prefix->stream[node->bit >> 3],
-                                 (0x80 >> (node->bit % 8))) ) {
-                node = node->right;
-            } else {
-                node = node->left;
-            }
-
-            if (node == NULL)
-                return NULL;
-        }
-
-        if (node->bit != prefix->bitlen || node->prefix == NULL)
-            return NULL;
-
-        if (memcmp(node->prefix->stream, prefix->stream, bytes) == 0) {
-            mask = -1 << (8 - prefix->bitlen % 8);
-
-            if (prefix->bitlen % 8 == 0 ||
-                (node->prefix->stream[bytes] & mask) == (prefix->stream[bytes] & mask)) {
-                if (SCRadixPrefixContainNetmaskAndSetUserData(node->prefix, prefix->bitlen, 0))
-                    return node;
-            }
-        }
-    }
-
-    return SCRadixFindKeyIPNetblock(prefix, netmask_node->parent);
-}
-
-/**
  * \brief Checks if an IP address key is present in the tree.  The function
  *        apart from handling any normal data, also handles ipv4/ipv6 netblocks
  *
diff --git a/src/util-radix-tree.h b/src/util-radix-tree.h
index f791760..6cfed45 100644
--- a/src/util-radix-tree.h
+++ b/src/util-radix-tree.h
@@ -108,5 +108,116 @@ void SCRadixPrintTree(SCRadixTree *);
 
 void SCRadixRegisterTests(void);
 
+void SCRadixReleasePrefix(SCRadixPrefix *, SCRadixTree *);
+int SCRadixPrefixContainNetmaskAndSetUserData(SCRadixPrefix *, uint16_t, int);
+/** ----- Inline funcions ------ */
+
+static inline SCRadixNode *SCRadixCreateNode();
+static inline void SCRadixReleaseNode(SCRadixNode *, SCRadixTree *);
+static inline SCRadixNode *SCRadixFindKeyIPNetblock(SCRadixPrefix *, SCRadixNode *);
+
+/**
+ * \brief Creates a new node for the Radix tree
+ *
+ * \retval node The newly created node for the radix tree
+ */
+static inline SCRadixNode *SCRadixCreateNode()
+{
+    SCRadixNode *node = NULL;
+
+    if ( (node = SCMalloc(sizeof(SCRadixNode))) == NULL) {
+        SCLogError(SC_ERR_MEM_ALLOC, "Error allocating memory");
+        exit(EXIT_FAILURE);
+    }
+    memset(node, 0, sizeof(SCRadixNode));
+
+    return node;
+}
+
+/**
+ * \brief Frees a Radix tree node
+ *
+ * \param node Pointer to a Radix tree node
+ * \param tree Pointer to the Radix tree to which this node belongs
+ */
+static inline void SCRadixReleaseNode(SCRadixNode *node, SCRadixTree *tree)
+{
+    if (node != NULL) {
+        SCRadixReleasePrefix(node->prefix, tree);
+        SCFree(node);
+    }
+
+    return;
+}
+
+/**
+ * \brief Checks if an IP prefix falls under a netblock, in the path to the root
+ *        of the tree, from the node.  Used internally by SCRadixFindKey()
+ *
+ * \param prefix Pointer to the prefix that contains the ip address
+ * \param node   Pointer to the node from where we have to climb the tree
+ */
+static inline SCRadixNode *SCRadixFindKeyIPNetblock(SCRadixPrefix *prefix,
+                                                    SCRadixNode *node)
+{
+    SCRadixNode *netmask_node = NULL;
+    int mask = 0;
+    int bytes = 0;
+    int i = 0;
+    int j = 0;
+
+    while (node != NULL && node->netmasks == NULL)
+        node = node->parent;
+
+    if (node == NULL)
+        return NULL;
+
+    /* hold the node found containing a netmask.  We will need it when we call
+     * this function recursively */
+    netmask_node = node;
+
+    for (j = 0; j < netmask_node->netmask_cnt; j++) {
+        bytes = prefix->bitlen / 8;
+        for (i = 0; i < bytes; i++) {
+            mask = -1;
+            if ( ((i + 1) * 8) > netmask_node->netmasks[j]) {
+                if ( ((i + 1) * 8 - netmask_node->netmasks[j]) < 8)
+                    mask = -1 << ((i + 1) * 8 - netmask_node->netmasks[j]);
+                else
+                    mask = 0;
+            }
+            prefix->stream[i] &= mask;
+        }
+
+        while (node->bit < prefix->bitlen) {
+            if (SC_RADIX_BITTEST(prefix->stream[node->bit >> 3],
+                                 (0x80 >> (node->bit % 8))) ) {
+                node = node->right;
+            } else {
+                node = node->left;
+            }
+
+            if (node == NULL)
+                return NULL;
+        }
+
+        if (node->bit != prefix->bitlen || node->prefix == NULL)
+            return NULL;
+
+        if (memcmp(node->prefix->stream, prefix->stream, bytes) == 0) {
+            mask = -1 << (8 - prefix->bitlen % 8);
+
+            if (prefix->bitlen % 8 == 0 ||
+                (node->prefix->stream[bytes] & mask) == (prefix->stream[bytes] & mask)) {
+                if (SCRadixPrefixContainNetmaskAndSetUserData(node->prefix, prefix->bitlen, 0))
+                    return node;
+            }
+        }
+    }
+
+    return SCRadixFindKeyIPNetblock(prefix, netmask_node->parent);
+}
+
+
 
 #endif /* __UTIL_RADIX_TREE_H__ */
diff --git a/src/util-spm-bm.c b/src/util-spm-bm.c
index 70e1af0..f345b9b 100644
--- a/src/util-spm-bm.c
+++ b/src/util-spm-bm.c
@@ -18,238 +18,4 @@
 #include <limits.h>
 #include <string.h>
 
-/**
- * \brief Array setup function for bad characters that split the pattern
- *        Remember that the result array should be the length of ALPHABET_SIZE
- *
- * \param str pointer to the pattern string
- * \param size length of the string
- * \param result pointer to an empty array that will hold the badchars
- */
-inline void PreBmBc(const uint8_t *x, int32_t m, int32_t *bmBc) {
-    int32_t i;
-
-    for (i = 0; i < 256; ++i) {
-        bmBc[i] = m;
-    }
-    for (i = 0; i < m - 1; ++i) {
-        bmBc[(unsigned char)x[i]] = m - i - 1;
-    }
-}
-
-/**
- * \brief Array setup function for building prefixes (shift for valid prefixes) for boyermoore context
- *
- * \param x pointer to the pattern string
- * \param m length of the string
- * \param suff pointer to an empty array that will hold the prefixes (shifts)
- */
-inline void BoyerMooreSuffixes(const uint8_t *x, int32_t m, int32_t *suff) {
-    int32_t f = 0, g, i;
-    suff[m - 1] = m;
-    g = m - 1;
-    for (i = m - 2; i >= 0; --i) {
-        if (i > g && suff[i + m - 1 - f] < i - g)
-            suff[i] = suff[i + m - 1 - f];
-        else {
-            if (i < g)
-                g = i;
-            f = i;
-            while (g >= 0 && x[g] == x[g + m - 1 - f])
-                --g;
-            suff[i] = f - g;
-        }
-    }
-}
-
-/**
- * \brief Array setup function for building prefixes (shift for valid prefixes) for boyermoore context
- *
- * \param x pointer to the pattern string
- * \param m length of the string
- * \param bmGs pointer to an empty array that will hold the prefixes (shifts)
- */
-inline void PreBmGs(const uint8_t *x, int32_t m, int32_t *bmGs) {
-    int32_t i, j;
-    int32_t *suff;
-
-    suff = SCMalloc(sizeof(int32_t) * (m + 1));
-
-    BoyerMooreSuffixes(x, m, suff);
-
-    for (i = 0; i < m; ++i)
-        bmGs[i] = m;
-
-    j = 0;
-
-    for (i = m - 1; i >= -1; --i)
-        if (i == -1 || suff[i] == i + 1)
-            for (; j < m - 1 - i; ++j)
-                if (bmGs[j] == m)
-                    bmGs[j] = m - 1 - i;
-
-    for (i = 0; i <= m - 2; ++i)
-        bmGs[m - 1 - suff[i]] = m - 1 - i;
-    SCFree(suff);
-}
-
-/**
- * \brief Array setup function for bad characters that split the pattern
- *        Remember that the result array should be the length of ALPHABET_SIZE
- *
- * \param str pointer to the pattern string
- * \param size length of the string
- * \param result pointer to an empty array that will hold the badchars
- */
-inline void PreBmBcNocase(const uint8_t *x, int32_t m, int32_t *bmBc) {
-    int32_t i;
-
-    for (i = 0; i < 256; ++i) {
-        bmBc[i] = m;
-    }
-    for (i = 0; i < m - 1; ++i) {
-        bmBc[u8_tolower((unsigned char)x[i])] = m - 1 - i;
-    }
-}
-
-inline void BoyerMooreSuffixesNocase(const uint8_t *x, int32_t m, int32_t *suff) {
-    int32_t f = 0, g, i;
-
-    suff[m - 1] = m;
-    g = m - 1;
-    for (i = m - 2; i >= 0; --i) {
-        if (i > g && suff[i + m - 1 - f] < i - g) {
-            suff[i] = suff[i + m - 1 - f];
-        } else {
-            if (i < g) {
-                g = i;
-            }
-            f = i;
-            while (g >= 0 && u8_tolower(x[g]) == u8_tolower(x[g + m - 1 - f])) {
-                --g;
-            }
-            suff[i] = f - g;
-        }
-    }
-}
-
-/**
- * \brief Array setup function for building prefixes (shift for valid prefixes)
- *        for boyermoore context case less
- *
- * \param x pointer to the pattern string
- * \param m length of the string
- * \param bmGs pointer to an empty array that will hold the prefixes (shifts)
- */
-inline void PreBmGsNocase(const uint8_t *x, int32_t m, int32_t *bmGs) {
-    int32_t i, j;
-    int32_t* suff;
-
-    suff = SCMalloc(sizeof(int32_t) * (m + 1));
-
-    BoyerMooreSuffixesNocase(x, m, suff);
-
-    for (i = 0; i < m; ++i) {
-        bmGs[i] = m;
-    }
-    j = 0;
-    for (i = m - 1; i >= 0; --i) {
-        if (i == -1 || suff[i] == i + 1) {
-            for (; j < m - 1 - i; ++j) {
-                if (bmGs[j] == m) {
-                    bmGs[j] = m - 1 - i;
-                }
-            }
-        }
-    }
-    for (i = 0; i <= m - 2; ++i) {
-        bmGs[m - 1 - suff[i]] = m - 1 - i;
-    }
-
-    SCFree(suff);
-}
-
-/**
- * \brief Boyer Moore search algorithm
- *        Is better as the pattern length increases and for big buffers to search in.
- *        The algorithm needs a context of two arrays already prepared
- *        by prep_bad_chars() and prep_good_suffix()
- *
- * \param y pointer to the buffer to search in
- * \param n length limit of the buffer
- * \param x pointer to the pattern we ar searching for
- * \param m length limit of the needle
- * \param bmBc pointer to an array of BoyerMooreSuffixes prepared by prep_good_suffix()
- * \param bmGs pointer to an array of bachars prepared by prep_bad_chars()
- *
- * \retval ptr to start of the match; NULL if no match
- */
-inline uint8_t *BoyerMoore(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc) {
-   int i, j, m1, m2;
-#if 0
-    printf("\nBad:\n");
-    for (i=0;i<ALPHABET_SIZE;i++)
-        printf("%c,%d ", i, bmBc[i]);
-
-    printf("\ngood:\n");
-    for (i=0;i<m;i++)
-        printf("%c, %d ", x[i],bmBc[i]);
-    printf("\n");
-#endif
-   j = 0;
-   while (j <= n - m ) {
-      for (i = m - 1; i >= 0 && x[i] == y[i + j]; --i);
-
-      if (i < 0) {
-         return y + j;
-         j += bmGs[0];
-      } else {
- //        printf("%c", y[i+j]);
-         j += (m1 = bmGs[i]) > (m2 = bmBc[y[i + j]] - m + 1 + i)? m1: m2;
-//            printf("%d, %d\n", m1, m2);
-      }
-   }
-   return NULL;
-}
-
-
-/**
- * \brief Boyer Moore search algorithm
- *        Is better as the pattern length increases and for big buffers to search in.
- *        The algorithm needs a context of two arrays already prepared
- *        by prep_bad_chars() and prep_good_suffix()
- *
- * \param y pointer to the buffer to search in
- * \param n length limit of the buffer
- * \param x pointer to the pattern we ar searching for
- * \param m length limit of the needle
- * \param bmBc pointer to an array of BoyerMooreSuffixes prepared by prep_good_suffix()
- * \param bmGs pointer to an array of bachars prepared by prep_bad_chars()
- *
- * \retval ptr to start of the match; NULL if no match
- */
-inline uint8_t *BoyerMooreNocase(uint8_t *x, int32_t m, uint8_t *y, int32_t n, int32_t *bmGs, int32_t *bmBc) {
-    int i, j, m1, m2;
-#if 0
-    printf("\nBad:\n");
-    for (i=0;i<ALPHABET_SIZE;i++)
-        printf("%c,%d ", i, bmBc[i]);
-
-    printf("\ngood:\n");
-    for (i=0;i<m;i++)
-        printf("%c, %d ", x[i],bmBc[i]);
-    printf("\n");
-#endif
-    j = 0;
-    while (j <= n - m ) {
-        for (i = m - 1; i >= 0 && u8_tolower(x[i]) == u8_tolower(y[i + j]); --i);
-
-        if (i < 0) {
-            return y + j;
-        } else {
-            j += (m1=bmGs[i]) > (m2=bmBc[u8_tolower(y[i + j])] - m + 1 + i)?m1:m2;
-        }
-   }
-   return NULL;
-}
 
